<?php

namespace IdelibreApiPhp\Tests\Api;

use IdelibreApiPhp\Api\v2\UserApiWrapper;
use IdelibreApiPhp\Client;
use IdelibreApiPhp\Enum\ApiPath;
use IdelibreApiPhp\Model\User;
use IdelibreApiPhp\Tests\Mocker\ClientMock;
use PHPUnit\Framework\MockObject\Exception;
use PHPUnit\Framework\TestCase;
use Psr\Http\Client\ClientExceptionInterface;
use Symfony\Component\PropertyInfo\Extractor\ReflectionExtractor;
use Symfony\Component\Serializer\Encoder\JsonEncoder;
use Symfony\Component\Serializer\Exception\ExceptionInterface;
use Symfony\Component\Serializer\Normalizer\ArrayDenormalizer;
use Symfony\Component\Serializer\Normalizer\DateTimeNormalizer;
use Symfony\Component\Serializer\Normalizer\GetSetMethodNormalizer;
use Symfony\Component\Serializer\Normalizer\ObjectNormalizer;
use Symfony\Component\Serializer\Serializer;

class UserApiWrapperTest extends TestCase
{
    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        $this->clientMock = new ClientMock(Client::class);
        $objectNormalizer = new ObjectNormalizer(null, null, null, new ReflectionExtractor());
        $getSetNormalizer = new GetSetMethodNormalizer();
        $dateTimeZoneNormalizer = new DateTimeNormalizer([DateTimeNormalizer::TIMEZONE_KEY => 'UTC']);
        $this->serializer = new Serializer([$objectNormalizer, $getSetNormalizer, new ArrayDenormalizer(),$dateTimeZoneNormalizer], [new JsonEncoder()]);
        $this->userApi = $this->clientMock->isApiUser();
    }



    /**
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testGetAll()
    {
        $apiResponse = '[
            {"id":"9aaee10e-368e-49c0-9052-f8d76e8666b0","username":"qidofod@libriciel","email":"cuvigoqika@mailinator.com","firstName":"Thor","lastName":"Owen","role":{"id":"eb74e130-b142-476c-9439-f06b58472a17","name":"Deputy","prettyName":"Suppl\u00e9ant"},"title":null,"gender":2,"isActive":false,"phone":null,"deputy":null,"createdAt":"2024-06-06T08:45:53+00:00","updatedAt":"2024-06-06T08:59:18+00:00"},
            {"id":"02b7a534-6477-4684-96fb-1c0eed3fbe96","username":"Orange@libriciel","email":"pmonin@libriciel.coop","firstName":"John","lastName":"Orange","role":{"id":"230a1c1d-eaec-4fb7-9ba7-d7ac47dc97bb","name":"Actor","prettyName":"Elu"},"title":"titre35","gender":1,"isActive":true,"phone":"0607121418","deputy":null,"createdAt":"2024-05-13T14:06:01+00:00","updatedAt":"2024-06-06T08:59:18+00:00"}
            ]'
        ;

        $structureId = $this->userApi->getStructure()->getId();
        $clientMock = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/users', $structureId), $apiResponse );

        $expected = [];
        foreach (json_decode($apiResponse, true) as $user) {
            $user['deputy'] ? $this->serializer->denormalize($user['deputy'], User::class) : $user['deputy'] = null;
            $expected[] = $this->serializer->denormalize($user, User::class, );
        }

        $userApiWrapper = new UserApiWrapper($clientMock);
        $response = $userApiWrapper->getAll();

        $this->assertCount(2, $response);
        $this->assertEquals($expected[0]->getLastName(), $response[0]->getLastName());
        $this->assertEquals($expected[1]->getLastName(), $response[1]->getLastName());
    }

    /**
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testGetOne()
    {
        $structureId = $this->userApi->getStructure()->getId();
        $apiResponse = '{"id":"9aaee10e-368e-49c0-9052-f8d76e8666b0","username":"qidofod@libriciel","email":"cuvigoqika@mailinator.com","firstName":"Thor","lastName":"Owen","role":{"id":"eb74e130-b142-476c-9439-f06b58472a17","name":"Deputy","prettyName":"Suppl\u00e9ant"},"party":null,"title":null,"gender":2,"isActive":false,"phone":null,"deputy":null,"createdAt":"2024-06-06T08:45:53+00:00","updatedAt":"2024-06-06T08:59:18+00:00"}';
        $userId = '9aaee10e-368e-49c0-9052-f8d76e8666b0';

        $clientMock = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/users/' . $userId, $structureId), $apiResponse);

        $expected = $this->serializer->denormalize(json_decode($apiResponse, true), User::class);


        $userApiWrapper = new UserApiWrapper($clientMock);
        $response = $userApiWrapper->getOne($userId);

        $this->assertInstanceOf(User::class, $response);
        $this->assertEquals($expected->getId(), $response->getId());
        $this->assertEquals($expected->getLastName(), $response->getLastName());
        $this->assertEquals($expected->getRole()->getPrettyName(), $response->getRole()->getPrettyName());
        $response->getDeputy() ? $this->assertEquals($expected->getDeputy()->getId(), $response->getDeputy()->getId()) : $this->assertNull($response->getDeputy());
    }

    /**
     * @throws Exception
     * @throws ClientExceptionInterface
     * @throws ExceptionInterface
     */
    public function testCreate()
    {
        $structureId = $this->userApi->getStructure()->getId();

        $apiResponse = '{"id":"9aaee10e-368e-49c0-9052-f8d76e8666b0","username":"qidofod@libriciel","email":"cuvigoqika@mailinator.com","firstName":"Thor","lastName":"Owen","role":{"id":"eb74e130-b142-476c-9439-f06b58472a17","name":"Deputy","prettyName":"Suppl\u00e9ant"},"party":null,"title":null,"gender":2,"isActive":false,"phone":null,"deputy":null,"createdAt":"2024-06-06T08:45:53+00:00","updatedAt":"2024-06-06T08:59:18+00:00","structure":{"id":"9ace114d-cc92-4aa0-8a55-865792e86f31","name":"Libriciel","replyTo":"bosepaluxe@mailinator.com","suffix":"libriciel","siren":"Totam nisi voluptas","legacyConnectionName":"libriciel","isActive":true,"canEditReplyTo":true,"group":{"id":"cf2491b7-cec7-4072-bd15-6603e6f69f04"},"timezone":{"id":"069c8728-47b1-447a-a818-2fe4655d9bd2","name":"Europe/Paris"}}}';
        $userToCreate = $this->serializer->deserialize($apiResponse, User::class, 'json');

        $clientMock = $this->clientMock->mockClient('post', sprintf(ApiPath::BASE_API_V2_PATH . '/users', $structureId), $apiResponse);

        $userApiWrapper = new UserApiWrapper($clientMock);
        $response = $userApiWrapper->create($userToCreate);

        $this->assertInstanceOf(User::class, $response);
        $this->assertEquals($userToCreate->getId(), $response->getId());
        $this->assertEquals($userToCreate->getLastName(), $response->getLastName());

    }

    /**
     * @throws ExceptionInterface
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testEdit()
    {
        $apiResponse = '{"id":"9aaee10e-368e-49c0-9052-f8d76e8666b0","username":"qidofod@libriciel","email":"cuvigoqika@mailinator.com","firstName":"Thor","lastName":"Owen","role":{"id":"eb74e130-b142-476c-9439-f06b58472a17","name":"Deputy","prettyName":"Suppl\u00e9ant"},"party":null,"title":null,"gender":2,"isActive":false,"phone":null,"deputy":null,"createdAt":"2024-06-06T08:45:53+00:00","updatedAt":"2024-06-06T08:59:18+00:00","structure":{"id":"9ace114d-cc92-4aa0-8a55-865792e86f31","name":"Libriciel","replyTo":"bosepaluxe@mailinator.com","suffix":"libriciel","siren":"Totam nisi voluptas","legacyConnectionName":"libriciel","isActive":true,"canEditReplyTo":true,"group":{"id":"cf2491b7-cec7-4072-bd15-6603e6f69f04"},"timezone":{"id":"069c8728-47b1-447a-a818-2fe4655d9bd2","name":"Europe/Paris"}}}';
        $userToCreate = $this->serializer->deserialize($apiResponse, User::class, 'json');

        $structureId = $this->userApi->getStructure()->getId();
        $userId = json_decode($apiResponse, true)['id'];

        $clientMock = $this->clientMock->mockClient('put', sprintf(ApiPath::BASE_API_V2_PATH . '/users/' . $userId, $structureId), $apiResponse);

        $userApiWrapper = new UserApiWrapper($clientMock);
        $response = $userApiWrapper->edit($userToCreate);

        $this->assertInstanceOf(User::class, $response);
        $this->assertEquals($userToCreate->getId(), $response->getId());
        $this->assertEquals($userToCreate->getLastName(), $response->getLastName());

    }

    /**
     * @throws ClientExceptionInterface
     * @throws Exception
     */
    public function testDelete()
    {

        $apiResponse = '{"id":"9aaee10e-368e-49c0-9052-f8d76e8666b0","username":"foody@libriciel","email":"cuvigoqika@mailinator.com","firstName":"Thor","lastName":"Owen","role":{"id":"eb74e130-b142-476c-9439-f06b58472a17","name":"Deputy","prettyName":"Suppl\u00e9ant"},"party":null,"title":null,"gender":2,"isActive":false,"phone":null,"deputy":null,"createdAt":"2024-06-06T08:45:53+00:00","updatedAt":"2024-06-06T08:59:18+00:00"}';

        $structureId = $this->userApi->getStructure()->getId();
        $userId = json_decode($apiResponse, true)['id'];

        $clientMock = $this->clientMock->mockClient('delete', sprintf(ApiPath::BASE_API_V2_PATH . '/users/' . $userId, $structureId), $apiResponse);
        $userApiWrapper = new UserApiWrapper($clientMock);
        $response = $userApiWrapper->delete($userId);

        $this->assertEquals(204, $response);
    }

}
